hdu 5074(简单dp)

Hatsune Miku

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 262144/262144 K (Java/Others)


Problem Description
Hatsune Miku is a popular virtual singer. It is very popular in both Japan and China. Basically it is a computer software that allows you to compose a song on your own using the vocal package.

Today you want to compose a song, which is just a sequence of notes. There are only m different notes provided in the package. And you want to make a song with n notes.


Also, you know that there is a system to evaluate the beautifulness of a song. For each two consecutive notes a and b, if b comes after a, then the beautifulness for these two notes is evaluated as score(a, b).

So the total beautifulness for a song consisting of notes a 1, a 2, . . . , a n, is simply the sum of score(a i, a i+1) for 1 ≤ i ≤ n - 1.

Now, you find that at some positions, the notes have to be some specific ones, but at other positions you can decide what notes to use. You want to maximize your song’s beautifulness. What is the maximum beautifulness you can achieve?
 

Input
The first line contains an integer T (T ≤ 10), denoting the number of the test cases.

For each test case, the first line contains two integers n(1 ≤ n ≤ 100) and m(1 ≤ m ≤ 50) as mentioned above. Then m lines follow, each of them consisting of m space-separated integers, the j-th integer in the i-th line for score(i, j)( 0 ≤ score(i, j) ≤ 100). The next line contains n integers, a 1, a 2, . . . , a n (-1 ≤ a i ≤ m, a i ≠ 0), where positive integers stand for the notes you cannot change, while negative integers are what you can replace with arbitrary notes. The notes are named from 1 to m.
 

Output
For each test case, output the answer in one line.
 

Sample Input
  
  
2 5 3 83 86 77 15 93 35 86 92 49 3 3 3 1 2 10 5 36 11 68 67 29 82 30 62 23 67 35 29 2 22 58 69 67 93 56 11 42 29 73 21 19 -1 -1 5 -1 4 -1 -1 -1 4 -1
 

Sample Output
  
  
270 625
 

解题思路:这道题目就要把-1的空填满,然后使得总分最大。挺简单的一个dp问题,直接dp[i][j]表示第i位上使用第j个音符所得到的前i个音符总和最大。因为第i位的音符只和第i-1位的音符有关,所以dp[i][j] = max{dp[i-1][k] + score[k][j]},然后一些音符固定的地方记得分类讨论下就ok!!总的来说是到很基础的dp

AC:
#include<iostream>
#include<cstdio>
#include<cstring>
using namespace std;

const int maxn = 55;
int n,m,a[maxn][maxn];
int note[maxn<<1],dp[maxn<<1][maxn];

int main()
{
	int t;
	cin>>t;
	while(t--)
	{
		cin>>n>>m;
		for(int i = 1; i <= m; i++)
			for(int j = 1; j <= m; j++)
				cin>>a[i][j];
		for(int i = 1; i <= n; i++)
			cin>>note[i];
		memset(dp,0,sizeof(dp));
		for(int i = 2; i <= n; i++)
		{
			if(note[i] == -1)
			{
				if(note[i-1] == -1)
				{
					for(int j = 1; j <= m; j++)
						for(int k = 1; k <= m; k++)
						{
							dp[i][j] = max(dp[i][j],dp[i-1][k] + a[k][j]);
						}
				}
				else
				{
					for(int j = 1; j <= m; j++)
						dp[i][j] = max(dp[i][j],dp[i-1][note[i-1]] + a[note[i-1]][j]);
				}
			}
			else
			{
				if(note[i-1] == -1)
				{
					for(int j = 1; j <= m; j++)
					{
						dp[i][note[i]] = max(dp[i][note[i]],dp[i-1][j] + a[j][note[i]]);
					}
				}
				else
				{
					dp[i][note[i]] = dp[i-1][note[i-1]] + a[note[i-1]][note[i]];
				}
			}
		}
		int ans = 0;
		for(int i = 1; i <= m; i++)
			ans = max(ans,dp[n][i]);
		cout<<ans<<endl;
	}
	return 0;
}


  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值